/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.connectors.jcr;

import java.net.MalformedURLException;
import org.exoplatform.services.jcr.rmi.RMIBinder;
import org.exoplatform.container.StandaloneContainer;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:lautarul@gmail.com">Roman Pedchenko</a>
 * @version $Id: RMIStarter.java 4056 2006-02-07 07:55:59Z lautarul $
 */

public class RMIStarter {

  public static void main(String[] argv) {
    int bind = 0;

    if (argv.length > 0) {
      for (int i = 0; i < argv.length; i++) {
        if (argv[i].equals("bind")) {
          bind = 1;
        } else
        if (argv[i].equals("unbind")) {
          bind = 2;
        } else
        if (bind != 2) {
          try {
            StandaloneContainer.setConfigurationPath(argv[i]);
          } catch(MalformedURLException e) {
            System.out.println("Error: malformed url in repository configuration, didn't set");
          }
        }
      }
    }
    try {
      StandaloneContainer sc = StandaloneContainer.getInstance();
      RMIBinder binder = (RMIBinder)sc.getComponentInstanceOfType(RMIBinder.class);
      if (bind == 1)
        binder.bind();
      else
      if (bind == 2)
        binder.unbind();
      System.out.println("JCR RMI service successfully started");
    } catch (Exception e) {
      System.out.println("Error: " + e);
      e.printStackTrace();
    }
  }

}
