/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.frameworks.jcr.command;

import java.io.InputStream;
import java.util.Calendar;

import javax.jcr.Node;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: JCRCommandHelper.java 5800 2006-05-28 18:03:31Z geaz $
 */

public class JCRCommandHelper {

  public static Node createResourceFile(Node parentNode, String relPath, 
      Object data, String mimeType) throws Exception {
    
    Node file = parentNode.addNode(relPath, "nt:file");
    Node contentNode = file.addNode("jcr:content", "nt:resource");
    
    if(data instanceof InputStream)
      contentNode.setProperty("jcr:data", (InputStream)data);
    else if(data instanceof String) 
      contentNode.setProperty("jcr:data", (String)data);
    else
      throw new Exception("Invalid object for jcr:data "+data);
    
    contentNode.setProperty("jcr:mimeType", mimeType);
    contentNode.setProperty("jcr:lastModified", Calendar.getInstance());
    return file;

  }
  
  
}
