/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.dataflow;

import java.util.List;

import javax.jcr.RepositoryException;

import org.exoplatform.services.jcr.datamodel.InternalQPath;
import org.exoplatform.services.jcr.datamodel.ItemData;
import org.exoplatform.services.jcr.datamodel.NodeData;
import org.exoplatform.services.jcr.datamodel.PropertyData;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: ItemDataConsumer.java 5150 2006-04-17 06:44:21Z geaz $
 * 
 * Basic (Level 1) data flow inmemory operations  
 *  
 * Common Rule for Read : If there is some storage in this manager 
 * try to get the data from here first, if not found  call super.someMethod
 */
public interface ItemDataConsumer {

  /**
   * @param path
   * @return data by path
   */
  ItemData getItemData(InternalQPath path) throws RepositoryException;

  /**
   * @param uuid
   * @return data by uuid
   */
  ItemData getItemData(String uuid) throws RepositoryException;

  /**
   * @param parentUUID
   * @return children data 
   */
  List <NodeData> getChildNodesData(NodeData parent) throws RepositoryException;

  /**
   * @param parentUUID
   * @return children data 
   */
  List <PropertyData> getChildPropertiesData(NodeData parent) throws RepositoryException;
  
  /**
   * @param uuid
   * @return
   * @throws RepositoryException
   */
  List <PropertyData> getReferencesData(String uuid) throws RepositoryException;
  
  /**
   * @param parent
   * @return
   * @throws RepositoryException
   */
  int getChildPropertiesCount(NodeData parent) throws RepositoryException;

  /**
   * @param parent
   * @return
   * @throws RepositoryException
   */
  int getChildNodesCount(NodeData parent) throws RepositoryException;

}
