/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.datamodel;

import java.util.List;

import org.exoplatform.services.jcr.access.AccessControlList;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: NodeData.java 5150 2006-04-17 06:44:21Z geaz $
 */

public interface NodeData extends ItemData {
	
	
	/**
	 * @return this node order number 
	 */
	int getOrderNumber();

	/**
	 * @return name of primary node type of this node. The jcr:primaryType property
	 * is loaded twice here and lazy initialized like others.
	 */
	InternalQName getPrimaryTypeName();
	
	/**
	 * @return names of mixin node types. The jcr:mixinTypes property
	 * is loaded twice here and lazy initialized like others.
	 * return empty array if no mixin types found
	 */
	InternalQName[] getMixinTypeNames();
	

	/**
   * @deprecated have to be replaced by ItemData.getACL()
	 * @return access control list for children's permission
	 */
	AccessControlList getChildrenACL();

  
  /**
   * @deprecated move it to TraverseableNodeData
   * @return set of child nodes' NodeData. NodeData should support lazy 
   * initialization of its children. It means that it is possible that NodeData
   * does not contain any children before calling getNodes()/getProperties() 
   * @throws IllegalStateException if child nodes could not be initialized
   */
  //List getChildNodes(); //throws IllegalStateException, RepositoryException

  /**
   * @deprecated move it to TraverseableNodeData 
   * @return set of child properties' PropertyData. The same lazy initialization policy as for
   * child nodes
   * @throws IllegalStateException
   */
  //List getChildProperties(); //throws IllegalStateException, RepositoryException


  /**
   * @deprecated [GA] Should be removed when session generate right sequence of changes  
   * @return this node order direction 
   * (lower than zero - shifted up to head, higher than zerro - sifted down to end) 
   * in the session 
   */
  int getOrderDirection();
  
  /**
   * @deprecated [GA] do we need this method? it seems no one used this
   * @return this node order status in the session 
   */
  boolean isOrdered();

}