/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype;

import javax.jcr.Value;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.PropertyDefinition;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: PropertyDefinitionImpl.java 5150 2006-04-17 06:44:21Z geaz $
 */

public class PropertyDefinitionImpl extends ItemDefinitionImpl implements PropertyDefinition {
	
	private int requiredType;

	private String[] valueConstraints;

	private Value[] defaultValues;

	private boolean multiple;

	public PropertyDefinitionImpl(String name, NodeType declaringNodeType,
			int requiredType, String[] valueConstraints, Value[] defaultValues,
			boolean autoCreate, boolean mandatory, int onVersion,
			boolean readOnly, boolean multiple) {

		super();
		this.name = name;
		this.declaringNodeType = declaringNodeType;
		this.requiredType = requiredType;
		this.valueConstraints = valueConstraints;
		this.defaultValues = defaultValues;
		this.autoCreate = autoCreate;
		this.mandatory = mandatory;
		this.onVersion = onVersion;
		this.readOnly = readOnly;
		this.multiple = multiple;
	}

	public PropertyDefinitionImpl() {
		super();
	}

	/**
	 * @see javax.jcr.nodetype.PropertyDefinition#getRequiredType
	 */
	public int getRequiredType() {
		return requiredType;
	}

	/**
	 * @see javax.jcr.nodetype.PropertyDefinition#getValueConstraints
	 */
	public String[] getValueConstraints() {
		return valueConstraints;
	}

	/**
	 * @see javax.jcr.nodetype.PropertyDefinition#getDefaultValues
	 */
	public Value[] getDefaultValues() {
		return defaultValues;
	}

	/**
	 * @see javax.jcr.nodetype.PropertyDefinition#isMultiple
	 */
	public boolean isMultiple() {
		return multiple;
	}

	/**
	 * @param defaultValues The defaultValues to set.
	 */
	public void setDefaultValues(Value[] defaultValues) {
		this.defaultValues = defaultValues;
	}

	/**
	 * @param multiple The multiple to set.
	 */
	public void setMultiple(boolean multiple) {
		this.multiple = multiple;
	}

	/**
	 * @param requiredType The requiredType to set.
	 */
	public void setRequiredType(int requiredType) {
		this.requiredType = requiredType;
	}

	/**
	 * @param valueConstraints The valueConstraints to set.
	 */
	public void setValueConstraints(String[] valueConstraints) {
		this.valueConstraints = valueConstraints;
	}

//	public String toString() {
//		return "PropertyDefImpl: " + name;
//	}

	public boolean equals(Object obj) {
		if (obj == null)
			return false;
		if (!(obj instanceof PropertyDefinitionImpl))
			return false;
		if (this.getName() == null)
			return ((PropertyDefinitionImpl) obj).getName() == null;
		return this.getName().equals(((PropertyDefinitionImpl) obj).getName());
	}
}
