/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.storage;

import org.exoplatform.services.jcr.JcrImplBaseTest;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov
 *         </a>
 * @version $Id: HibernateWorkspaceContainerTest.java 5185 2006-04-19 09:03:04Z peterit $
 */

public class HibernateWorkspaceContainerTest extends JcrImplBaseTest {
/*
	protected RDBWorkspaceContainerImpl wsContainer;

	protected LocationFactory locationFactory;
	
	protected JCRPath rootLoc;
	
	protected UUIDGenerator uuidGenerator;

	public void setUp() throws Exception {

		super.setUp();

		this.wsContainer = (RDBWorkspaceContainerImpl) container
				.getComponentInstanceOfType(WorkspaceDataContainer.class);

		this.locationFactory = new LocationFactory(
				new NamespaceRegistryImpl(this.logService)); 
		
		this.uuidGenerator = new UUIDGenerator(new IDGeneratorServiceImpl());

		this.rootLoc = locationFactory.createRootLocation();

	}

	public void tearDown() throws Exception {
		super.tearDown();
	}

	public void testAddRoot() throws Exception {

		wsContainer.add(createNodeData("/", "nt:unstructured", 0, null));
		NodeData root = (NodeData)wsContainer.getItem(rootLoc.getInternalPath());
		assertNotNull(root);
		assertEquals(Constants.ROOT_URI, root.getQPath().getAsString());
		assertEquals("nt:unstructured", locationFactory.createJCRName(root.getPrimaryTypeName()).getAsString());

	}

	public void testAddProperty() throws Exception {

		PropertyData testData = createPropertyData("/exo:test",
				PropertyType.STRING, new TransientValueData("test"), 
				getParent("/exo:test").getUUID());
		
		wsContainer.add(testData);

		PropertyData propData = (PropertyData) wsContainer.getItem(locationFactory.
				parseAbsPath("/exo:test").getInternalPath());
		assertNotNull(propData);
		assertNotNull(propData.getValues());
//		System.out.println(">>> Property Data >>>"+propData.getValues());

		assertEquals("test", new String(((ValueData) propData.getValues()
				.get(0)).getAsByteArray()));

		MultiRDBNodeRecord parent1 = (MultiRDBNodeRecord) wsContainer.getItem(rootLoc.getInternalPath());
//		System.out.println(">>> Initialized >>>"+Hibernate.isInitialized(
//				parent1));
		
		//assertNotNull(parent1.getChildProperties());
		//Hibernate.initialize(parent1.getChildProperties());
		//assertEquals(2, parent1.getChildProperties().size());
		

//		parent1.addProperty((PropertyRecord) propData);
		//		assertEquals(1, parent1.getProperties().size());

	}

	public void testAddNode() throws Exception {

		NodeData testData = wsContainer.add(createNodeData("/node1", 
		    "nt:unstructured", 0, getParent("/node1").getUUID()));

		NodeData nodeData = (NodeData) wsContainer.getItem(testData.getQPath());
		assertNotNull(nodeData);
		assertTrue(testData.getQPath().equals(nodeData.getQPath()));
		assertEquals("nt:unstructured", 
				locationFactory.createJCRName(nodeData.getPrimaryTypeName()).getAsString());
		assertEquals(0, nodeData.getOrderNumber());
		
		testData = wsContainer.add(createNodeData("/node1[2]", 
		    "nt:unstructured", 1, getParent("/node1[2]").getUUID()));
		NodeData nodeData1 = (NodeData) wsContainer.getItem(testData.getQPath());
		assertEquals(1, nodeData1.getOrderNumber());

		MultiRDBNodeRecord parent1 = (MultiRDBNodeRecord) wsContainer.getItem(rootLoc.getInternalPath());
		assertNotNull(parent1.getChildNodes());
		assertEquals(2, parent1.getChildNodes().size());

		testData = wsContainer.add(createNodeData("/node1/node2", 
		    "nt:unstructured", 0, getParent("/node1/node2").getUUID()));
		nodeData = (NodeData) wsContainer.getItem(testData.getQPath());
		assertEquals(0, nodeData.getOrderNumber());
		assertTrue(testData.getQPath().equals(nodeData.getQPath()));
		
	}
	
	public void testUpdateNode() throws Exception {

		InternalQPath loc = locationFactory.
		parseAbsPath("/node1").getInternalPath();
		NodeData nodeData = (NodeData) wsContainer.getItem(loc);
		// MIXIN
		assertEquals(0, nodeData.getMixinTypeNames().length);
		PropertyData mixinProp = createPropertyData(
				locationFactory.parseAbsPath("/node1/jcr:mixinTypes").getAsString(false), 
				PropertyType.NAME, 
				new TransientValueData(
				locationFactory.parseJCRName("mix:referenceable").getInternalName()),
				getParent("/node1/jcr:mixinTypes").getUUID());
		wsContainer.add(mixinProp);
		nodeData = (NodeData) wsContainer.getItem(loc);
		assertEquals(1, nodeData.getMixinTypeNames().length);
		System.out.println(">>>>"+locationFactory.parseJCRName("mix:referenceable")
				.getInternalName().getAsString()+" "+
				nodeData.getMixinTypeNames()[0].getAsString());
		assertTrue(locationFactory.parseJCRName("mix:referenceable")
				.getInternalName().equals( 
				nodeData.getMixinTypeNames()[0]));
		// order number
	}
	
	public void testUpdateProperty() throws Exception {

		PropertyData testData = (PropertyData) wsContainer.getItem(locationFactory.
				parseAbsPath("/exo:test").getInternalPath());

		List vals = new ArrayList();
		vals.add((ValueData)testData.getValues().get(0));
		vals.add(new TransientValueData("test1"));
		vals.add(new TransientValueData("test2"));
		testData.setValues(vals);

		wsContainer.update(testData);
		PropertyData propData = (PropertyData) wsContainer.getItem(testData.getQPath());
		assertNotNull(propData);
		assertEquals(3, propData.getValues().size());
		
		assertEquals("test1", new String(((ValueData) propData.getValues().get(
				1)).getAsByteArray()));

		testData.getValues().remove(1);
		wsContainer.update(testData);
		propData = (PropertyData) wsContainer.getItem(testData.getQPath());
		assertEquals(2, propData.getValues().size());


	}

	public void testDeleteProperty() throws Exception {
		
		InternalQPath loc = locationFactory.
		  parseAbsPath("/exo:test").getInternalPath();
		PropertyData propData = (PropertyData) wsContainer.getItem(loc);
		assertNotNull(propData);

		wsContainer.delete(propData);
		propData = (PropertyData) wsContainer.getItem(loc);
		assertNull(propData);

	}

	public void testDeleteNode() throws Exception {

		InternalQPath loc = locationFactory.
		  parseAbsPath("/node1").getInternalPath();
		NodeData nodeData = (NodeData) wsContainer.getItem(loc);
		assertNotNull(nodeData);
		
		//		
		wsContainer.delete(nodeData);
		nodeData = (NodeData) wsContainer.getItem(loc);
		assertNull(nodeData);
		// delete cascade
		InternalQPath loc1 = locationFactory.
		  parseAbsPath("/node1/node2").getInternalPath();
		nodeData = (NodeData) wsContainer.getItem(loc1);
		assertNull(nodeData);
		//		

		// root still here
		nodeData = (NodeData) wsContainer.getItem(rootLoc.getInternalPath());
		assertNotNull(nodeData);

	}
	

	public void testGetItem() throws Exception {
		NodeData testData = wsContainer.add(createNodeData("/exo:testNode1", 
				"nt:unstructured", 0, getParent("/exo:testNode1").getUUID()));
		NodeData nodeData = (NodeData)wsContainer.getItemByUUID(testData.getUUID());
		assertNotNull(nodeData);

		assertTrue(testData.getQPath().equals(nodeData.getQPath()));
		nodeData = (NodeData)wsContainer.getItem(testData.getQPath());

		assertTrue(testData.getQPath().equals(nodeData.getQPath()));
		
		InternalQPath loc = locationFactory.
		  parseAbsPath("/").getInternalPath();
		NodeData root = (NodeData) wsContainer.getItem(loc);
		assertTrue(root.getChildNodes().size() > 0);

	}

	public void testGetReferences() throws Exception {
		
		List refs = wsContainer.getReferences("1234");
		assertTrue(refs.isEmpty());

		PropertyData propData = wsContainer.add(createPropertyData("/exo:testProp", 
				PropertyType.REFERENCE, 
				new TransientValueData(new Uuid("1234")),
				getParent("/exo:testProp").getUUID()
				));

		refs = wsContainer.getReferences("1234");
		assertEquals(1, refs.size());
		PropertyData prop = (PropertyData)refs.get(0);
		assertTrue(prop.getQPath().equals(propData.getQPath()));

	}
	
	private NodeData createNodeData(String path, String ptName, 
	    int orderNum, String parentUUID) 
	throws RepositoryException {
		InternalQPath qpath = locationFactory.parseAbsPath(path).getInternalPath();
		String uuid = uuidGenerator.generateStringUUID(path);
		InternalQName pt = locationFactory.parseJCRName(ptName).getInternalName();
		InternalQName[] mt = new InternalQName[0];
		TransientNodeData node = new TransientNodeData(qpath, uuid, -1, pt, 
				mt, orderNum, parentUUID);
		
		InternalQPath ptPath = locationFactory.createJCRPath(locationFactory.createJCRPath(qpath), 
				"jcr:primaryType").getInternalPath();
		String ptUuid = uuidGenerator.generateStringUUID(ptPath.getAsString());
		PropertyData ptProperty = new TransientPropertyData(ptPath, 
				ptUuid, -1, PropertyType.NAME, parentUUID, true);
		List values = new ArrayList();
		values.add(new TransientValueData(pt));
		ptProperty.setValues(values);

		node.addProperty(ptProperty);
		return node; 
		
	}

	private PropertyData createPropertyData(String path, int type, 
	    ValueData value, String parentUUID) 
	throws RepositoryException {
		
		InternalQPath propPath = locationFactory.parseAbsPath(path).getInternalPath();
		String propUuid = uuidGenerator.generateStringUUID(path);
		PropertyData prop = new TransientPropertyData(propPath, 
				propUuid, -1, type, parentUUID, true);
		List vals = new ArrayList();
		vals.add(value);
		prop.setValues(vals);
		return prop; 
		
	}
	
	private NodeData getParent(String path) throws RepositoryException {
		InternalQPath qpath = locationFactory.parseAbsPath(path).makeParentPath().
		getInternalPath();
		return (NodeData)wsContainer.getItem(qpath);
	}
*/
}