/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.rmi;

import java.util.*;
import javax.naming.*;
import javax.naming.spi.*;
import javax.jcr.*;
import java.rmi.*;
import java.net.MalformedURLException;
import org.apache.jackrabbit.rmi.client.*;
import org.apache.jackrabbit.rmi.remote.*;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:lautarul@gmail.com">Roman Pedchenko</a>
 * @version $Id: RepositoryFactory.java 3846 2006-01-18 14:08:07Z lautarul $
 */

public class RepositoryFactory implements ObjectFactory {
    public static final String URL_PARAMETER = "url";
    private LocalAdapterFactory factory;

    public RepositoryFactory() {
        factory = new ClientAdapterFactory();
    }

    public synchronized Repository getRepository(String url) throws
            ClassCastException, MalformedURLException, NotBoundException, RemoteException {
        RemoteRepository remote = (RemoteRepository) Naming.lookup(url);
        Repository repository = new RMIRepositoryWrapper(url, factory.getRepository(remote));
        return repository;
    }

    private Repository getRepository(RefAddr url) throws NamingException {
        try {
            return getRepository((String) url.getContent());
        } catch (Exception ex) {
            throw new NamingException(ex.getMessage());
        }
    }

    public Object getObjectInstance(
            Object object, Name name, Context context, Hashtable environment)
            throws NamingException {
        if (object instanceof Reference) {
            Reference reference = (Reference) object;
//            if (Repository.class.getName().equals(reference.getClassName())) {
                RefAddr url = reference.get(URL_PARAMETER);
                if (url != null) {
                    return getRepository(url);
                }
//            }
        }
        return null;
    }
}
